/// @cond EO_CXX_EO_IMPL

inline ::eldbus::model_method::_c_constructor eldbus::model_method::constructor(Eldbus_Proxy * proxy_, const Eldbus_Introspection_Method * method_)
{
   return _c_constructor(proxy_, method_);
}

inline Efl_Model_Load_Status eldbus::model_method::call() const
{
   Efl_Model_Load_Status _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::eldbus_model_method_call());
   return _tmp_ret;
}

inline Efl_Model_Load_Status eo_cxx::eldbus::model_method::call() const
{
   Efl_Model_Load_Status _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::eldbus_model_method_call());
   return _tmp_ret;
}

inline ::eo_cxx::eldbus::model_method::operator ::eldbus::model_method() const
{
   return *static_cast<::eldbus::model_method const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::eldbus::model_method::operator ::eldbus::model_method&()
{
   return *static_cast<::eldbus::model_method*>(static_cast<void*>(this));
}

inline ::eo_cxx::eldbus::model_method::operator ::eldbus::model_method const&() const
{
   return *static_cast<::eldbus::model_method const*>(static_cast<void const*>(this));
}

template <typename T>
Efl_Model_Load_Status eldbus_model_method_call_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->call();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Efl_Model_Load_Status _tmp_ret{};
         return _tmp_ret;
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::eldbus::model_method >
{
   template <typename T>
   struct type
         : virtual operations< ::eldbus::model_arguments >::template type<T>
   {
      virtual Efl_Model_Load_Status call()
      {
         Efl_Model_Load_Status _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::eldbus_model_method_call());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::eldbus::model_method >
{
   static constexpr int value = 
#if defined(MODEL_METHOD_PROTECTED) && defined(MODEL_METHOD_BETA)
      1
#elif defined(MODEL_METHOD_PROTECTED)
      1
#elif defined(MODEL_METHOD_BETA)
      1
#else
      1
#endif
      + operation_description_class_size<::eldbus::model_arguments >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::eldbus::model_method>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::eldbus_model_method_call_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::eldbus_model_method_call);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eldbus::model_arguments>(), &ops[operation_description_class_size< ::eldbus::model_method >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::eldbus::model_method>)
{
   return (ELDBUS_MODEL_METHOD_CLASS);
}

} } }

/// @endcond

